- 前缀和与差分
- @[toc]
- 什么是前缀和
- 一维前缀和
- 预处理:
- 公式推导:
- 例题:AcWing 795. 前缀和
- 输入格式
- 输出格式
- 数据范围
- 输入样例:
- 输出样例:
- AC代码:
- 二维前缀和
- 公式推导:
- 例题1:AcWing 796. 子矩阵的和
- 输入格式
- 输出格式
- 数据范围
- 输入样例:
- 输出样例:
- AC代码:
- 例题2 第十三届蓝桥杯C++B组 试题 F: 统计子矩阵
- 【问题描述】
- 【输入格式】
- 【输出格式】
- 【样例输入】
- 【样例输出】
- 【样例说明】
- 【评测用例规模与约定】
- 二维前缀和+四重循环暴力代码:
- 什么是差分
- 一维差分
- 差分数组:
- 区间修改:
- 公式推导:
- 例题 AcWing 797. 差分
- 输入格式
- 输出格式
- 数据范围
- 输出样例:
- AC代码:
- 二维差分
- 差分数组:
- 公式推导:
- 理解:
- 例题 AcWing 798. 差分矩阵
- 输入格式
- 输出格式
- 数据范围
- 输入样例:
- 输出样例:
- AC代码
前缀和指一个数组的某下标之前的所有数组元素的和(包含其自身)。前缀和分为一维前缀和,以及二维前缀和。前缀和是一种重要的预处理,能够降低算法的时间复杂度, 快速求出元素组中某段区间的和。
一维前缀和 预处理:设一维数组为a[N], 前缀和数组为s[N], 要求的区间为[l, r] (l <= r)
公式推导:s[0] = a[0] s[1] = a[0] + a[1] = s[0] + a[1] s[2] = a[0] + a[1] + a[2] = s[1] + a[2] s[3] = a[0] + a[1] + a[2] + a[3] = s[2] + a[3] s[4] = a[0] + a[1] + a[2] + a[3] + a[4] = s[3] + a[4] .......... s[n] = s[n - 1] + a[n] s[r] = a[1] + a[2] + ... + a[l - 1] + a[l] + a[l + 1]+ ... a[r] s[l - 1] = a[1] + a[2] + ... + a[l - 1] s[r] - s[l - 1] = a[l] + a[l + 1] + ... + a[r]
则公式如下
一维前缀和:
s
[
i
]
=
s
[
i
−
1
]
+
a
[
i
]
,区间和:
i
n
t
e
r
v
a
l
[
l
,
r
]
=
s
[
r
]
−
s
[
l
−
1
]
一维前缀和:s[i] = s[i - 1] + a[i], 区间和:interval [l, r] = s[r] - s[l - 1]
一维前缀和:s[i]=s[i−1]+a[i],区间和:interval[l,r]=s[r]−s[l−1]
输入一个长度为 n 的整数序列。
接下来再输入 m 个询问,每个询问输入一对 l,r。
对于每个询问,输出原序列中从第 ll个数到第 r 个数的和。
输入格式第一行包含两个整数 n 和 m。
第二行包含 n 个整数,表示整数数列。
接下来 m 行,每行包含两个整数 ll和 r,表示一个询问的区间范围。
输出格式共 m 行,每行输出一个询问的结果。
数据范围1≤l≤r≤n
1≤n,m≤100000
−1000≤数列中元素的值≤1000
5 3 2 1 3 6 4 1 2 1 3 2 4输出样例:
3 6 10AC代码:
#include二维前缀和 公式推导:using namespace std; const int N = 1e5 + 7; int n, m, a[N], s[N]; int main() { cin >> n >> m; for (int i = 1; i <= n; ++i) { cin >> a[i]; } for (int i = 1; i <= n; ++i) { s[i] = s[i - 1] + a[i];// 前缀和的初始化 } while (m--) { int l, r; cin >> l >> r; cout << s[r] - s[l - 1] << 'n';// 区间和的计算 } return 0; }
如图:
每一个颜色的矩形面积都代表了它所包围元素的和 求前缀和就是求粉色矩形面积
粉色矩形:左上角(1, 1)到右下角(i, j)的矩形面积
绿色矩形:左上角(1, 1)到右下角(i, j - 1)的矩形面积
黄色矩形:左上角(1, 1)到右下角(i - 1, j)的矩形面积
蓝色矩形:左上角(1, 1)到右下角(i - 1, j - 1)的矩形面积
红色矩形:左上角(i- 1, j - 1)到右下角(i, j)的矩形面积
则二维前缀和公式如下:
s
[
i
]
[
j
]
=
s
[
i
−
1
]
[
j
]
+
s
[
i
]
[
j
−
1
]
+
a
[
i
]
[
j
]
−
s
[
i
−
1
]
[
j
−
1
]
s[i][j] = s[i - 1][j] + s[i][j - 1] +a[i][j] - s[i - 1][j - 1]
s[i][j]=s[i−1][j]+s[i][j−1]+a[i][j]−s[i−1][j−1]
下面来推导区间和
如图:
以(x1, y1)(x2, y2)为区间的左上角、右下角
易得:
i
n
t
e
r
v
a
l
[
(
x
1
,
y
1
)
−
>
(
x
2
,
y
2
)
]
=
s
[
x
2
]
[
y
2
]
−
s
[
x
1
−
1
]
[
y
2
]
−
s
[
x
2
]
[
y
1
−
1
]
+
s
[
x
1
−
1
]
[
y
1
−
1
]
interval[ (x1, y1) -> (x2, y2) ] = s[x2][y2] - s[x1 - 1][y2] - s[x2][y1 - 1] + s[x1 - 1][y1 - 1]
interval[(x1,y1)−>(x2,y2)]=s[x2][y2]−s[x1−1][y2]−s[x2][y1−1]+s[x1−1][y1−1]
输入一个 n 行 m 列的整数矩阵,再输入 q 个询问,每个询问包含四个整数 x1,y1,x2,y2,表示一个子矩阵的左上角坐标和右下角坐标。
对于每个询问输出子矩阵中所有数的和。
输入格式第一行包含三个整数 n,m,q
接下来 n 行,每行包含 m 个整数,表示整数矩阵。
接下来 q 行,每行包含四个整数 x1,y1,x2,y2,表示一组询问。
输出格式共 qq 行,每行输出一个询问的结果。
数据范围1≤n,m≤1000,
1≤q≤200000,
1≤x1≤x2≤n,
1≤y1≤y2≤m,
−1000≤矩阵内元素的值≤1000−1000≤矩阵内元素的值≤1000
3 4 3 1 7 2 4 3 6 2 8 2 1 2 3 1 1 2 2 2 1 3 4 1 3 3 4输出样例:
17 27 21AC代码:
#include例题2 第十三届蓝桥杯C++B组 试题 F: 统计子矩阵 【问题描述】using namespace std; const int N = 1e3 + 7; int n, m, q; int a[N][N], s[N][N]; int main() { cin >> n >> m >> q; for (int i = 1; i <= n; ++i) { for (int j = 1; j <= m; ++j) { cin >> a[i][j]; } } for (int i = 1; i <= n; ++i) { for (int j = 1; j <= m; ++j) { s[i][j] = s[i - 1][j] + s[i][j - 1] - s[i - 1][j - 1] + a[i][j]; } } while (q--) { int x1, y1, x2, y2; cin >> x1 >> y1 >> x2 >> y2; cout << s[x2][y2] - s[x1 - 1][y2] - s[x2][y1 - 1] + s[x1 - 1][y1 - 1] << 'n'; } return 0; }
给定一个 N × M 的矩阵 A,请你统计有多少个子矩阵 (最小 1 × 1,最大
N × M) 满足子矩阵中所有数的和不超过给定的整数 K?
第一行包含三个整数 N, M 和 K.
之后 N 行每行包含 M 个整数,代表矩阵 A.
一个整数代表答案。
【样例输入】3 4 10 1 2 3 4 5 6 7 8 9 10 11 12【样例输出】
19【样例说明】
满足条件的子矩阵一共有 19,包含:
大小为 1 × 1 的有 10 个。
大小为 1 × 2 的有 3 个。
大小为 1 × 3 的有 2 个。
大小为 1 × 4 的有 1 个。
大小为 2 × 1 的有 3 个。
对于 30% 的数据,N, M ≤ 20.
对于 70% 的数据,N, M ≤ 100.
对于 100% 的数据,1 ≤ N, M ≤ 500; 0 ≤ Ai j ≤ 1000; 1 ≤ K ≤ 250000000
#includeusing namespace std; typedef long long LL; const int N = 510; LL a[N][N], s[N][N], n, m, k, res = 0; int main() { cin >> n >> m >> k; for (int i = 1; i <= n; i++) { for (int j = 1; j <= m; j++) { cin >> a[i][j]; s[i][j] = s[i - 1][j] + s[i][j - 1] + a[i][j] - s[i - 1][j - 1]; } } for (int x1 = 1; x1 <= n; x1++) { for (int y1 = 1; y1 <= m; y1++) { for (int x2 = x1; x2 <= n; x2++) { for (int y2 = y1; y2 <= m; y2++) { LL subMatrix = s[x2][y2] - s[x1 - 1][y2] - s[x2][y1 - 1] + s[x1 - 1][y1 - 1]; if (subMatrix <= k) res++; } } } } cout << res << endl; return 0; }
本题正确做法为二维前缀和+双指针,时间复杂度降到O(n^3)
什么是差分
差分(difference)又名差分函数或差分运算,差分的结果反映了离散量之间的一种变化,是研究离散数学的一种工具。 它将原函数f (x) 映射到f (x+a)-f (x+b) 。差分可以看作前缀和的逆运算。
一维差分 差分数组:我们设原数组a[], b[]为原数组的差分数组 那么差分数组b[]的求解公式就为
b
[
i
]
=
a
[
i
]
−
a
[
i
−
1
]
(
i
>
=
1
)
b[i] = a[i] - a[i - 1] (i >= 1)
b[i]=a[i]−a[i−1](i>=1)
给定区间[l ,r ],让我们把a数组中的[ l, r]区间中的每一个数都加上c,即 a[l] + c , a[l+1] + c , a[l+2] + c … a[r] + c,暴力做法是for循环l到r区间,时间复杂度O(n),如果我们需要对原数组执行m次这样的操作,时间复杂度就会变成O(n*m)
我们可以使用差分数组来实现区间修改的时间复杂度为O(1)
公式推导:a数组是b数组的前缀和数组,比如对b数组的b[i]的修改,会影响到a数组中从a[i]及往后的每一个数。
首先让差分b数组中的 b[l] + c , a数组变成 a[l] + c ,a[l+1] + c…a[n] + c;
然后我们打个补丁,b[r+1] - c, a数组变成 a[r+1] - c,a[r+2] - c…a[n] - c;
对区间[l, r]进行修改加上c:
b
[
l
]
+
=
c
,
b
[
r
−
1
]
−
=
c
b[l] += c, b[r - 1] -= c
b[l]+=c,b[r−1]−=c
输入一个长度为 nn 的整数序列。
接下来输入 mm 个操作,每个操作包含三个整数 l,r,cl,r,c,表示将序列中 [l,r][l,r] 之间的每个数加上 cc。
请你输出进行完所有操作后的序列。
输入格式第一行包含两个整数 n 和 m。
第二行包含 n 个整数,表示整数序列。
接下来 m 行,每行包含三个整数 l,r,c,表示一个操作。
输出格式共一行,包含 nn 个整数,表示最终序列。
数据范围1≤n,m≤100000
1≤l≤r≤n
−1000≤c≤1000
−1000≤整数序列中元素的值≤1000
6 3 1 2 2 1 2 1 1 3 1 3 5 1 1 6 1输出样例:
3 4 5 3 4 2AC代码:
#includeusing namespace std; const int N = 1e5 + 7; int n, m, l, r, c, a[N], b[N]; //前缀和差分互为逆运算 int main() { cin >> n >> m; for (int i = 1; i <= n; i++) { cin >> a[i]; b[i] = a[i] - a[i - 1]; // a数组是b数组的前缀数组 b数组是a数组的差分数组 } while (m--) { cin >> l >> r >> c; b[l] += c; //表示l - n 全部 +c b[r + 1] -= c; //表示 r + 1 ~ n 全部 -c } for (int i = 1; i <= n; i++) { a[i] = b[i] + a[i - 1]; //通过差分数组b求其前缀和 即原数组a cout << a[i] << ' '; } return 0; }
二维差分 差分数组:
给定原二维数组a ,二维数组b为原数组a的差分数组, 数组a为数组b的前缀和矩阵
使得a数组中a(i, j)是b数组左上角(1, 1)到右下角(i, j)所包围的矩形的元素和
构造公式:
b
[
i
]
[
j
]
=
a
[
i
]
[
j
]
−
a
[
i
]
[
j
−
1
]
−
a
[
i
−
1
]
[
j
]
+
a
[
i
−
1
]
[
j
−
1
]
;
b[i][j] = a[i][j] - a[i][j - 1] - a[i - 1][j] + a[i - 1][j - 1];
b[i][j]=a[i][j]−a[i][j−1]−a[i−1][j]+a[i−1][j−1];
b[x1][ y1 ] +=c ; 让整个a数组中绿色矩形面积的元素都加上了c。
b[x1,][y2+1]-=c ; 让整个a数组中红色矩形面积的元素再减去c,使其内元素不发生改变。
b[x2+1][y1]- =c ; 让整个a数组中紫色矩形面积的元素再减去c,使其内元素不发生改变。
b[x2+1][y2+1]+=c; 让整个a数组中黑色矩形面积的元素再加上c,黑色内的相当于被减了两次,再加上一次c,才能使其恢复。
b
[
x
1
]
[
y
1
]
+
=
c
;
b
[
x
2
+
1
]
[
y
1
]
−
=
c
;
b
[
x
1
]
[
y
2
+
1
]
−
=
c
;
b
[
x
2
+
1
]
[
y
2
+
1
]
+
=
c
;
b[x1][y1]+=c; b[x2+1][y1]-=c; b[x1][y2+1]-=c; b[x2+1][y2+1]+=c;
b[x1][y1]+=c;b[x2+1][y1]−=c;b[x1][y2+1]−=c;b[x2+1][y2+1]+=c;
我们将其封装成一个函数
void insert(int &x1, int &y1, int &x2, int &y2, int &c) {
b[x1][y1] += c;
b[x1][y2 + 1] -= c;
b[x2 + 1][y1] -= c;
b[x2 + 1][y2 + 1] += c;
}
理解:
我们可以先假想a数组为空,那么b数组一开始也为空,但是实际上a数组并不为空,因此我们每次让以(i,j)为左上角到以(i,j)为右下角面积内元素(其实就是一个小方格的面积)去插入 c=a[i][j],等价于原数组a中(i,j) 到(i,j)范围内 加上了 a[i][j] ,因此执行n*m次插入操作,就成功构建了差分b数组.
例题 AcWing 798. 差分矩阵输入一个 nn 行 mm 列的整数矩阵,再输入 qq 个操作,每个操作包含五个整数 x1,y1,x2,y2,cx1,y1,x2,y2,c,其中 (x1,y1)(x1,y1) 和 (x2,y2)(x2,y2) 表示一个子矩阵的左上角坐标和右下角坐标。
每个操作都要将选中的子矩阵中的每个元素的值加上 cc。
请你将进行完所有操作后的矩阵输出。
输入格式第一行包含整数 n,m,q。
接下来 n 行,每行包含 m 个整数,表示整数矩阵。
接下来 q 行,每行包含 5 个整数 x1,y1,x2,y2,c表示一个操作。
输出格式共 n 行,每行 m 个整数,表示所有操作进行完毕后的最终矩阵。
数据范围1≤n,m≤1000
1≤q≤100000
1≤x1≤x2≤n
1≤y1≤y2≤m
−1000≤c≤1000
−1000≤矩阵内元素的值≤1000
3 4 3 1 2 2 1 3 2 2 1 1 1 1 1 1 1 2 2 1 1 3 2 3 2 3 1 3 4 1输出样例:
2 3 4 1 4 3 4 1 2 2 2 2AC代码
#include暑期编程PK赛 得CSDN机械键盘等精美礼品!using namespace std; const int N = 1e3 + 7; int n, m, q; int a[N][N], b[N][N]; void insert(int &x1, int &y1, int &x2, int &y2, int &c) { b[x1][y1] += c; b[x1][y2 + 1] -= c; b[x2 + 1][y1] -= c; b[x2 + 1][y2 + 1] += c; } int main() { cin >> n >> m >> q; for (int i = 1; i <= n; ++i) { for (int j = 1; j <= m; ++j) { cin >> a[i][j]; } } for (int i = 1; i <= n; ++i) { for (int j = 1; j <= m; ++j) { insert(i, j, i, j, a[i][j]); //b[i][j] = a[i][j] - a[i][j - 1] - a[i - 1][j] + a[i - 1][j - 1]; } } while (q--) { int x1, y1, x2, y2, c; cin >> x1 >> y1 >> x2 >> y2 >> c; insert(x1, y1, x2, y2, c); } for (int i = 1; i <= n; ++i) { for (int j = 1; j <= m; ++j) { a[i][j] = a[i - 1][j] + a[i][j - 1] - a[i - 1][j - 1] + b[i][j]; } } for (int i = 1; i <= n; ++i) { for (int j = 1; j <= m; ++j) { cout << a[i][j] << ' '; } cout << 'n'; } return 0; }



